CREATE OR REPLACE PROCEDURE GERA_CODRECEITA_VENC_MAPA(
   P_NRSEQUMAPAPU    IN MAPAAPURAC.NRSEQUMAPAPU%TYPE,
   P_DTINICIAL       IN MAPAAPURAC.DTINIPERIODO%TYPE,
   P_DTFINAL         IN MAPAAPURAC.DTINIPERIODO%TYPE,
   P_CDEMPRESA       IN MAPAAPURAC.CDEMPRESA%TYPE,
   P_CDINSCRICAO     IN MAPAAPURAC.CDINSCESTA%TYPE,
   P_CDIMPOSTO       IN MAPAAPURAC.CDIMPOSTO%TYPE)
AS
   V_ENTRSAID           NUMBER;
   V_ORGAO_ARRECAD      VARCHAR(1);
   V_CDRECEITA          MAPAAPURAC.CDRECEGUIA%TYPE;
   V_CDFORMPGTO         FORMPGTO.CDFORMPGTO%TYPE;
   V_NRDIAFIXVENC       NUMBER;
   V_IDVENCDIANAOUTIL   VARCHAR(1);
   V_CDFILIALCALEND     VARCHAR(4);
   V_IDTPCALEND         VARCHAR(1);
   V_VRIMPOSTONF        FLOAT;
   V_IDTIPODTPGTO       FORMPGTO.IDTIPODTPGTO%TYPE;
   V_IDTPPERIODO        FORMPGTO.IDTPPERIODO%TYPE;
   V_IDCONSDIAUTIL      FORMPGTO.IDCONSDIAUTIL%TYPE;
   V_DTVENCIMENTO       DATE;
   V_NRSEQGUIACOMPL     NUMBER;
   V_TOTALGUIACOMPL     FLOAT;
   V_VRMAPA             FLOAT;

 /*CORRIGE A DATA DE VENCIMENTO CONSIDERANDO FERIADO BANCRIO*/
   PROCEDURE CONSISTE_FERI_BANC(P_CDFILIEMIRECE IN VARCHAR2,
                                P_DTVENCIMENTO IN DATE,
                                P_DTVENC OUT DATE,
                                P_IDCONSDIAUTIL IN VARCHAR2,
                                P_IDTPPERIODO IN VARCHAR2,
                                P_IDTPCALEND IN VARCHAR2,
                                P_IDVENCDIANAOUTIL IN VARCHAR2)
   IS
      V_BOFERI BOOLEAN;
      V_NRDIASFERI NUMBER;
      V_DTANTERIOR DATE;
   BEGIN
      IF (P_IDCONSDIAUTIL = 'S') AND (P_IDTPPERIODO <> 'S')  THEN
        V_BOFERI := TRUE;
      ELSE
        V_BOFERI := FALSE;
      END IF;
      P_DTVENC := P_DTVENCIMENTO;

      WHILE V_BOFERI LOOP  
         BEGIN
            IF P_IDTPCALEND = 'F' THEN
               SELECT COUNT(*)
                 INTO V_NRDIASFERI
                 FROM FERIFILI
                WHERE CDFILIAL = P_CDFILIEMIRECE
                  AND DTFERIFILI BETWEEN P_DTVENCIMENTO AND P_DTVENC;
            ELSIF P_IDTPCALEND = 'C' THEN
               SELECT COUNT(*)
                 INTO V_NRDIASFERI
                 FROM FERICOMP
                WHERE CDFILIAL = P_CDFILIEMIRECE
                  AND DTFERICOMP BETWEEN P_DTVENCIMENTO AND P_DTVENC;
            ELSE
               SELECT COUNT(*)
                 INTO V_NRDIASFERI
                 FROM FERIBANC
                WHERE CDFILIAL = P_CDFILIEMIRECE
                  AND DTFERIBANC BETWEEN P_DTVENCIMENTO AND P_DTVENC;
            END IF;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_NRDIASFERI := 0;
         END;

         IF NOT(V_NRDIASFERI = 0) THEN
            V_DTANTERIOR := P_DTVENC;
            /*VERIFICA SE PRORROGA OU ANTECIPA O VENCIMENTO CASO SEJA FERIADO*/
            IF P_IDVENCDIANAOUTIL = 'A' THEN
               P_DTVENC := P_DTVENC - V_NRDIASFERI;
            ELSE
               P_DTVENC := P_DTVENC + V_NRDIASFERI;
            END IF;

            WHILE V_BOFERI LOOP
               IF P_IDVENCDIANAOUTIL = 'A' THEN
                  V_DTANTERIOR := V_DTANTERIOR - 1;
               ELSE
                  V_DTANTERIOR := V_DTANTERIOR + 1;
               END IF;
               
               BEGIN
                  IF P_IDTPCALEND = 'F' THEN
                     SELECT COUNT(*)
                       INTO V_NRDIASFERI
                       FROM FERIFILI
                      WHERE CDFILIAL = P_CDFILIEMIRECE
                        AND DTFERIFILI BETWEEN V_DTANTERIOR AND P_DTVENC;
                  ELSIF P_IDTPCALEND = 'C' THEN
                     SELECT COUNT(*)
                       INTO V_NRDIASFERI
                       FROM FERICOMP
                      WHERE CDFILIAL = P_CDFILIEMIRECE
                        AND DTFERICOMP BETWEEN V_DTANTERIOR AND P_DTVENC;
                  ELSE
                     SELECT COUNT(*)
                       INTO V_NRDIASFERI
                       FROM FERIBANC
                      WHERE CDFILIAL = P_CDFILIEMIRECE
                        AND DTFERIBANC BETWEEN V_DTANTERIOR AND P_DTVENC;
                  END IF;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_NRDIASFERI := 0;
               END;
               IF V_NRDIASFERI > 0 THEN
                  V_DTANTERIOR := P_DTVENC;
                  IF P_IDVENCDIANAOUTIL = 'A' THEN
                     P_DTVENC := P_DTVENC - V_NRDIASFERI;
                  ELSE
                     P_DTVENC := P_DTVENC + V_NRDIASFERI;
                  END IF;
               ELSE
                  V_BOFERI := FALSE;
               END IF;
            END LOOP;
         ELSE
            V_BOFERI := FALSE;
         END IF;
      END LOOP;
      IF ((P_IDCONSDIAUTIL = 'S') AND (P_IDTPPERIODO = 'S')) THEN
         BEGIN
            IF P_IDTPCALEND = 'F' THEN
               SELECT COUNT(*)
                 INTO V_NRDIASFERI
                 FROM FERIFILI
                WHERE CDFILIAL   = P_CDFILIEMIRECE
                  AND DTFERIFILI = P_DTVENC;
            ELSIF P_IDTPCALEND = 'C' THEN
               SELECT COUNT(*)
                 INTO V_NRDIASFERI
                 FROM FERICOMP
                WHERE CDFILIAL   = P_CDFILIEMIRECE
                  AND DTFERICOMP = P_DTVENC;
            ELSE
               SELECT COUNT(*)
                 INTO V_NRDIASFERI
                 FROM FERIBANC
                WHERE CDFILIAL   = P_CDFILIEMIRECE
                  AND DTFERIBANC = P_DTVENC;
            END IF;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_NRDIASFERI := 0;
         END;
         P_DTVENC := P_DTVENC + NVL(V_NRDIASFERI,0);
      END IF; 
   END;
BEGIN     
   BEGIN
     /*VERIFICA SE TEM ENTRADA E SAIDA NA APURACAO, OU APENAS UM OU OUTRO*/
     SELECT COUNT(DISTINCT N.IDENTRSAIDOP)
       INTO V_ENTRSAID
       FROM NOTAFISCAL N, IMPOSTONF IP
      WHERE (IP.NRSEQUMAPAPU = P_NRSEQUMAPAPU OR IP.NRSEQMAPOIMP = P_NRSEQUMAPAPU)
        AND N.CDFILIAL      = IP.CDFILIAL
        AND N.NRLANCTONF    = IP.NRLANCTONF;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_ENTRSAID := 0;
   END;

   BEGIN
     SELECT IDORGARRECADNFE
       INTO V_ORGAO_ARRECAD
       FROM IMPOSTONFE  I
      WHERE CDIMPOSTONFE = P_CDIMPOSTO;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_ORGAO_ARRECAD := NULL;
   END;

   /*APURACAO DEBITO MENOS CREDITO*/
   IF V_ENTRSAID = 2 THEN
      /*BUSCA CODIGO DA RECEITA POR LOCALIDADE*/
      /*FEDERAL*/
      IF V_ORGAO_ARRECAD = 'F' THEN
         BEGIN
            SELECT MAX(P.CDRECEITA), MAX(P.CDFORMPGTO), MAX(P.NRDIAFIXVENC), MAX(P.IDVENCDIANAOUTIL), MAX(P.CDFILIALCALEND), MAX(P.IDTPCALEND)
              INTO V_CDRECEITA, V_CDFORMPGTO, V_NRDIAFIXVENC, V_IDVENCDIANAOUTIL, V_CDFILIALCALEND, V_IDTPCALEND
              FROM PARAMBENEFIMP B, PARAMGUIAIMPLOCAL P, IMPOSTO I, EMPRESA E
             WHERE E.CDEMPRESA    = P_CDEMPRESA
               AND E.CDPAIS       = B.CDPAIS
               AND B.IDTPPARAMBENEF = 'F'
               AND I.CDIMPOSTONFE = P_CDIMPOSTO
               AND P.CDIMPOSTO    = I.CDIMPOSTO
               AND P.NRSEQPARAMBENIMP = B.NRSEQPARAMBENIMP;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDRECEITA        := NULL;
               V_CDFORMPGTO       := NULL;
               V_NRDIAFIXVENC     := NULL;
               V_IDVENCDIANAOUTIL := NULL;
               V_CDFILIALCALEND   := NULL;
               V_IDTPCALEND       := NULL;
         END;
      END IF;

      /*ESTADUAL*/
      IF V_ORGAO_ARRECAD = 'E' THEN
         BEGIN
            SELECT MAX(P.CDRECEITA), MAX(P.CDFORMPGTO), MAX(P.NRDIAFIXVENC), MAX(P.IDVENCDIANAOUTIL), MAX(P.CDFILIALCALEND), MAX(P.IDTPCALEND)
              INTO V_CDRECEITA, V_CDFORMPGTO, V_NRDIAFIXVENC, V_IDVENCDIANAOUTIL, V_CDFILIALCALEND, V_IDTPCALEND
              FROM PARAMBENEFIMP B, PARAMGUIAIMPLOCAL P, IMPOSTO I, INSCRESTAD IE
             WHERE IE.CDEMPRESA    = P_CDEMPRESA
               AND IE.CDINSCESTA   = P_CDINSCRICAO
               AND IE.CDPAIS       = B.CDPAIS
               AND IE.SGESTADO     = B.SGESTADO
               AND B.IDTPPARAMBENEF  = 'E'
               AND I.CDIMPOSTONFE  = P_CDIMPOSTO
               AND P.CDIMPOSTO     = I.CDIMPOSTO
               AND P.NRSEQPARAMBENIMP = B.NRSEQPARAMBENIMP;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDRECEITA        := NULL;
               V_CDFORMPGTO       := NULL;
               V_NRDIAFIXVENC     := NULL;
               V_IDVENCDIANAOUTIL := NULL;
               V_CDFILIALCALEND   := NULL;
               V_IDTPCALEND       := NULL;
         END;
      END IF;

      /*MUNICIPAL*/
      IF V_ORGAO_ARRECAD = 'M' THEN
         BEGIN
            SELECT MAX(P.CDRECEITA), MAX(P.CDFORMPGTO), MAX(P.NRDIAFIXVENC), MAX(P.IDVENCDIANAOUTIL), MAX(P.CDFILIALCALEND), MAX(P.IDTPCALEND)
              INTO V_CDRECEITA, V_CDFORMPGTO, V_NRDIAFIXVENC, V_IDVENCDIANAOUTIL, V_CDFILIALCALEND, V_IDTPCALEND
              FROM PARAMBENEFIMP B, PARAMGUIAIMPLOCAL P, IMPOSTO I, INSCRMUNICIP IM
             WHERE IM.CDEMPRESA    = P_CDEMPRESA
               AND IM.CDINSCMUNI   = P_CDINSCRICAO
               AND IM.CDPAIS       = B.CDPAIS
               AND IM.SGESTADO     = B.SGESTADO
               AND IM.CDMUNICIPIO  = B.CDMUNICIPIO
               AND B.IDTPPARAMBENEF = 'M'
               AND I.CDIMPOSTONFE = P_CDIMPOSTO
               AND P.CDIMPOSTO    = I.CDIMPOSTO
               AND P.NRSEQPARAMBENIMP = B.NRSEQPARAMBENIMP;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDRECEITA        := NULL;
               V_CDFORMPGTO       := NULL;
               V_NRDIAFIXVENC     := NULL;
               V_IDVENCDIANAOUTIL := NULL;
               V_CDFILIALCALEND   := NULL;
               V_IDTPCALEND       := NULL;
         END;
      END IF;

      IF V_CDRECEITA IS NULL THEN
        /*BUSCA CODIGO DA RECEITA POR IMPOSTO*/
        BEGIN
           SELECT CDRECEITA, CDFORMPGTO, NRDIAFIXVENC, IDVENCDIANAOUTIL, CDFILIALCALEND, IDTPCALEND
             INTO V_CDRECEITA, V_CDFORMPGTO, V_NRDIAFIXVENC, V_IDVENCDIANAOUTIL, V_CDFILIALCALEND, V_IDTPCALEND
             FROM PARAMIMPOSGUIA P
            WHERE P.CDIMPOSTO = P_CDIMPOSTO;
        EXCEPTION
           WHEN NO_DATA_FOUND THEN
              V_CDRECEITA        := NULL;
              V_CDFORMPGTO       := NULL;
              V_NRDIAFIXVENC     := NULL;
              V_IDVENCDIANAOUTIL := NULL;
              V_CDFILIALCALEND   := NULL;
              V_IDTPCALEND       := NULL;
        END;
      END IF;

      IF V_CDRECEITA IS NOT NULL THEN
         IF V_NRDIAFIXVENC IS NULL THEN 
            V_DTVENCIMENTO := P_DTFINAL+1;
         ELSE
            IF V_NRDIAFIXVENC > TO_NUMBER(TO_CHAR(LAST_DAY(ADD_MONTHS(P_DTINICIAL, 1)),'DD')) THEN 
               V_DTVENCIMENTO := LAST_DAY(ADD_MONTHS(P_DTINICIAL,1));
            ELSE
               V_DTVENCIMENTO := TO_DATE(TO_CHAR(V_NRDIAFIXVENC)||'/'||TO_CHAR(ADD_MONTHS(P_DTINICIAL, 1), 'MM/YYYY'), 'DD/MM/YYYY');
            END IF;
         END IF;

         /* VERIFICA A FORMA DE PAGAMENTO */
         IF V_CDFORMPGTO IS NOT NULL THEN
            SELECT IDTIPODTPGTO, IDTPPERIODO, IDCONSDIAUTIL
              INTO V_IDTIPODTPGTO, V_IDTPPERIODO, V_IDCONSDIAUTIL
              FROM FORMPGTO
             WHERE CDFORMPGTO = V_CDFORMPGTO;

            IF V_IDTPPERIODO = 'M' THEN
               V_DTVENCIMENTO := UTIL_CRIAVENCIMENTO.DIAMES(V_CDFORMPGTO,
                                                            V_DTVENCIMENTO);
            ELSIF V_IDTPPERIODO = 'S' THEN
               V_DTVENCIMENTO := UTIL_CRIAVENCIMENTO.DIASEMANA(V_CDFORMPGTO,
                                                               V_DTVENCIMENTO);
            ELSE
               V_DTVENCIMENTO := UTIL_CRIAVENCIMENTO.DIASEMANAMES(V_CDFORMPGTO,
                                                                  V_DTVENCIMENTO);
            END IF;
            CONSISTE_FERI_BANC(V_CDFILIALCALEND,
                               V_DTVENCIMENTO,
                               V_DTVENCIMENTO,
                               V_IDCONSDIAUTIL,
                               V_IDTPPERIODO,
                               V_IDTPCALEND,
                               V_IDVENCDIANAOUTIL);
         ELSE
            CONSISTE_FERI_BANC(V_CDFILIALCALEND,
                               V_DTVENCIMENTO,
                               V_DTVENCIMENTO,
                               'S',
                               'N',
                               V_IDTPCALEND,
                               V_IDVENCDIANAOUTIL);
         END IF;

         UPDATE MAPAAPURAC
           SET VRRECEGUIA   = NVL(VRTOTAIMPOS,0),
               VRMULTAGUIA  = NVL(VRMULTAGUIA,0),
               VRJUROGUIA   = NVL(VRJUROGUIA,0),
               VRTOTAGUIA   = NVL(VRRECEGUIA,0) + NVL(VRMULTAGUIA,0) + NVL(VRJUROGUIA,0),
               DTVENCGUIA   = V_DTVENCIMENTO,
               CDRECEGUIA   = V_CDRECEITA
         WHERE NRSEQUMAPAPU = P_NRSEQUMAPAPU;
      END IF;
   ELSE
      V_NRSEQGUIACOMPL := 0;
      IF V_ORGAO_ARRECAD = 'F' THEN
         FOR C_FEDERAL IN (SELECT SUM(IP.VRIMPOSTONF) AS VRIMPOSTO, P.CDIMPOSTO, P.CDRECEITA, P.CDFORMPGTO, P.NRDIAFIXVENC, P.IDVENCDIANAOUTIL, P.CDFILIALCALEND, P.IDTPCALEND
                             FROM PARAMBENEFIMP B, PARAMGUIAIMPLOCAL P, IMPOSTO I, EMPRESA E, IMPOSTONF IP
                            WHERE E.CDEMPRESA         = P_CDEMPRESA
                              AND E.CDPAIS            = B.CDPAIS
                              AND B.IDTPPARAMBENEF    = 'F'
                              AND I.CDIMPOSTONFE      = P_CDIMPOSTO
                              AND P.CDIMPOSTO         = I.CDIMPOSTO
                              AND P.NRSEQPARAMBENIMP  = B.NRSEQPARAMBENIMP
                              AND P.CDIMPOSTO         = IP.CDIMPOSTO
                              AND (IP.NRSEQUMAPAPU    = P_NRSEQUMAPAPU OR IP.NRSEQMAPOIMP = P_NRSEQUMAPAPU)
                           GROUP BY P.CDIMPOSTO, P.CDRECEITA, P.CDFORMPGTO, P.NRDIAFIXVENC, P.IDVENCDIANAOUTIL, P.CDFILIALCALEND, P.IDTPCALEND) LOOP

                 --IF C_FEDERAL.CDRECEITA IS NOT NULL
                    IF V_NRDIAFIXVENC IS NULL THEN
                       V_DTVENCIMENTO := P_DTFINAL+1;
                    ELSE
                    IF V_NRDIAFIXVENC > TO_NUMBER(TO_CHAR(LAST_DAY(ADD_MONTHS(P_DTINICIAL, 1)),'DD')) THEN
                       V_DTVENCIMENTO := LAST_DAY(ADD_MONTHS(P_DTINICIAL,1));
                    ELSE
                       V_DTVENCIMENTO := TO_DATE(TO_CHAR(V_NRDIAFIXVENC)||'/'||TO_CHAR(ADD_MONTHS(P_DTINICIAL, 1), 'MM/YYYY'), 'DD/MM/YYYY');
                    END IF;
                 --END IF;

                 /* VERIFICA A FORMA DE PAGAMENTO */
                 IF V_CDFORMPGTO IS NOT NULL THEN
                    SELECT IDTIPODTPGTO, IDTPPERIODO, IDCONSDIAUTIL
                      INTO V_IDTIPODTPGTO, V_IDTPPERIODO, V_IDCONSDIAUTIL
                      FROM FORMPGTO
                     WHERE CDFORMPGTO = V_CDFORMPGTO;

                    IF V_IDTPPERIODO = 'M' THEN
                       V_DTVENCIMENTO := UTIL_CRIAVENCIMENTO.DIAMES(V_CDFORMPGTO,
                                                                    V_DTVENCIMENTO);
                    ELSIF V_IDTPPERIODO = 'S' THEN
                       V_DTVENCIMENTO := UTIL_CRIAVENCIMENTO.DIASEMANA(V_CDFORMPGTO,
                                                                       V_DTVENCIMENTO);
                    ELSE
                       V_DTVENCIMENTO := UTIL_CRIAVENCIMENTO.DIASEMANAMES(V_CDFORMPGTO,
                                                                          V_DTVENCIMENTO);
                    END IF;
                    CONSISTE_FERI_BANC(V_CDFILIALCALEND,
                                       V_DTVENCIMENTO,
                                       V_DTVENCIMENTO,
                                       V_IDCONSDIAUTIL,
                                       V_IDTPPERIODO,
                                       V_IDTPCALEND,
                                       V_IDVENCDIANAOUTIL);
                 ELSE
                    CONSISTE_FERI_BANC(V_CDFILIALCALEND,
                                       V_DTVENCIMENTO,
                                       V_DTVENCIMENTO,
                                       'S',
                                       'N',
                                       V_IDTPCALEND,
                                       V_IDVENCDIANAOUTIL);
                 END IF;

                 V_NRSEQGUIACOMPL := V_NRSEQGUIACOMPL+1;
                 /* GERA GUIA COMPLEMENTAR */
                 IF C_FEDERAL.CDRECEITA IS NOT NULL THEN
                    INSERT INTO GUIACOMPLMAPA
                       (NRSEQUMAPAPU, NRSEQGUIACOMPL, CDOBRIGAGUIA, CDRECEITAGUIA, DTVENCGUIACOMPL, IDORIGEMGUIA, VRRECEITAGUIA)
                    VALUES
                       (P_NRSEQUMAPAPU, LPAD(V_NRSEQGUIACOMPL,10,0), LPAD(V_NRSEQGUIACOMPL,5,0), C_FEDERAL.CDRECEITA, V_DTVENCIMENTO, '9', C_FEDERAL.VRIMPOSTO);

                    V_TOTALGUIACOMPL := V_TOTALGUIACOMPL + C_FEDERAL.VRIMPOSTO;
                 END IF;
              END IF;
         END LOOP;

         /*BUSCA CODIGO DA RECEITA POR IMPOSTO PARA GRAVAR OS DADOS NA GUIA DO MAPA*/
         BEGIN
            SELECT CDRECEITA, CDFORMPGTO, NRDIAFIXVENC, IDVENCDIANAOUTIL, CDFILIALCALEND, IDTPCALEND
              INTO V_CDRECEITA, V_CDFORMPGTO, V_NRDIAFIXVENC, V_IDVENCDIANAOUTIL, V_CDFILIALCALEND, V_IDTPCALEND
              FROM PARAMIMPOSGUIA P
             WHERE P.CDIMPOSTO = P_CDIMPOSTO;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDRECEITA        := NULL;
               V_CDFORMPGTO       := NULL;
               V_NRDIAFIXVENC     := NULL;
               V_IDVENCDIANAOUTIL := NULL;
               V_CDFILIALCALEND   := NULL;
               V_IDTPCALEND       := NULL;
         END;

         IF V_NRDIAFIXVENC IS NULL THEN
            V_DTVENCIMENTO := P_DTFINAL+1;
         ELSE
            IF V_NRDIAFIXVENC > TO_NUMBER(TO_CHAR(LAST_DAY(ADD_MONTHS(P_DTINICIAL, 1)),'DD')) THEN
               V_DTVENCIMENTO := LAST_DAY(ADD_MONTHS(P_DTINICIAL,1));
            ELSE
               V_DTVENCIMENTO := TO_DATE(TO_CHAR(V_NRDIAFIXVENC)||'/'||TO_CHAR(ADD_MONTHS(P_DTINICIAL, 1), 'MM/YYYY'), 'DD/MM/YYYY');
            END IF;
         END IF;

         /* VERIFICA A FORMA DE PAGAMENTO */
         IF V_CDFORMPGTO IS NOT NULL THEN
            SELECT IDTIPODTPGTO, IDTPPERIODO, IDCONSDIAUTIL
              INTO V_IDTIPODTPGTO, V_IDTPPERIODO, V_IDCONSDIAUTIL
              FROM FORMPGTO
             WHERE CDFORMPGTO = V_CDFORMPGTO;

            IF V_IDTPPERIODO = 'M' THEN
               V_DTVENCIMENTO := UTIL_CRIAVENCIMENTO.DIAMES(V_CDFORMPGTO,
                                                            V_DTVENCIMENTO);
            ELSIF V_IDTPPERIODO = 'S' THEN
               V_DTVENCIMENTO := UTIL_CRIAVENCIMENTO.DIASEMANA(V_CDFORMPGTO,
                                                               V_DTVENCIMENTO);
            ELSE
               V_DTVENCIMENTO := UTIL_CRIAVENCIMENTO.DIASEMANAMES(V_CDFORMPGTO,
                                                                  V_DTVENCIMENTO);
            END IF;
            CONSISTE_FERI_BANC(V_CDFILIALCALEND,
                               V_DTVENCIMENTO,
                               V_DTVENCIMENTO,
                               V_IDCONSDIAUTIL,
                               V_IDTPPERIODO,
                               V_IDTPCALEND,
                               V_IDVENCDIANAOUTIL);
         ELSE
            CONSISTE_FERI_BANC(V_CDFILIALCALEND,
                               V_DTVENCIMENTO,
                               V_DTVENCIMENTO,
                               'S',
                               'N',
                               V_IDTPCALEND,
                               V_IDVENCDIANAOUTIL);
         END IF;

         /*GERA GUIA COMPLEMENTAR E A GUIA DO MAPA REFERENTE AO IMPOSTONE, CASO NAO TENHA PARAMETRO POR LOCALIDADE*/
         IF V_TOTALGUIACOMPL = 0 THEN
            SELECT VRTOTAIMPOS
              INTO V_VRMAPA
              FROM MAPAAPURAC
             WHERE NRSEQUMAPAPU = P_NRSEQUMAPAPU;

            INSERT INTO GUIACOMPLMAPA
               (NRSEQUMAPAPU, NRSEQGUIACOMPL, CDOBRIGAGUIA, CDRECEITAGUIA, DTVENCGUIACOMPL, IDORIGEMGUIA, VRRECEITAGUIA)
            VALUES
               (P_NRSEQUMAPAPU, LPAD(V_NRSEQGUIACOMPL,10,0), LPAD(V_NRSEQGUIACOMPL,5,0), V_CDRECEITA, V_DTVENCIMENTO, '9', V_VRMAPA);
               
            UPDATE MAPAAPURAC
               SET VRRECEGUIA   = VRTOTAIMPOS,
                   VRMULTAGUIA  = NVL(VRMULTAGUIA,0),
                   VRJUROGUIA   = NVL(VRJUROGUIA,0),
                   VRTOTAGUIA   = NVL(VRRECEGUIA,0) + NVL(VRMULTAGUIA,0) + NVL(VRJUROGUIA,0),
                   DTVENCGUIA   = V_DTVENCIMENTO,
                   CDRECEGUIA   = V_CDRECEITA
             WHERE NRSEQUMAPAPU = P_NRSEQUMAPAPU;
         ELSE
            UPDATE MAPAAPURAC
               SET VRRECEGUIA   = V_TOTALGUIACOMPL,
                   VRMULTAGUIA  = NVL(VRMULTAGUIA,0),
                   VRJUROGUIA   = NVL(VRJUROGUIA,0),
                   VRTOTAGUIA   = NVL(VRRECEGUIA,0) + NVL(VRMULTAGUIA,0) + NVL(VRJUROGUIA,0),
                   DTVENCGUIA   = V_DTVENCIMENTO,
                   CDRECEGUIA   = V_CDRECEITA
             WHERE NRSEQUMAPAPU = P_NRSEQUMAPAPU;

           /*VERIFICA SE TEM IMPOSTO QUE NAO TA PARAMETRIZADO NA LOCALIDADE POREM ESTA RELACIONADO AO IMPOSTONFE, GERANDO A GUIA PRINCIPAL COM A DIFERENCA*/
            BEGIN
               SELECT SUM(IP.VRIMPOSTONF)
                 INTO V_VRIMPOSTONF
                 FROM IMPOSTONF IP, IMPOSTO I
                WHERE (IP.NRSEQUMAPAPU = P_NRSEQUMAPAPU OR IP.NRSEQMAPOIMP = P_NRSEQUMAPAPU)
                  AND I.CDIMPOSTONFE  = P_CDIMPOSTO
                  AND IP.CDIMPOSTO    = I.CDIMPOSTO
                  AND NOT EXISTS (SELECT PL.CDIMPOSTO
                                    FROM PARAMBENEFIMP B, PARAMGUIAIMPLOCAL PL, IMPOSTO I, EMPRESA E
                                   WHERE E.CDEMPRESA         = P_CDEMPRESA
                                     AND E.CDPAIS            = B.CDPAIS
                                     AND B.IDTPPARAMBENEF    = 'F'
                                     AND I.CDIMPOSTONFE      = P_CDIMPOSTO
                                     AND PL.CDIMPOSTO        = I.CDIMPOSTO
                                     AND PL.NRSEQPARAMBENIMP = B.NRSEQPARAMBENIMP
                                     AND IP.CDIMPOSTO        = PL.CDIMPOSTO);
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                 V_VRIMPOSTONF      := 0;
                 V_CDRECEITA        := NULL;
                 V_CDFORMPGTO       := NULL;
                 V_NRDIAFIXVENC     := NULL;
                 V_IDVENCDIANAOUTIL := NULL;
                 V_CDFILIALCALEND   := NULL;
                 V_IDTPCALEND       := NULL;
            END;

            IF V_VRIMPOSTONF > 0 THEN
               UPDATE MAPAAPURAC
               SET VRRECEGUIA   = V_VRIMPOSTONF,
                   VRMULTAGUIA  = NVL(VRMULTAGUIA,0),
                   VRJUROGUIA   = NVL(VRJUROGUIA,0),
                   VRTOTAGUIA   = NVL(VRRECEGUIA,0) + NVL(VRMULTAGUIA,0) + NVL(VRJUROGUIA,0),
                   DTVENCGUIA   = V_DTVENCIMENTO,
                   CDRECEGUIA   = V_CDRECEITA;
            END IF;
         END IF;
      END IF;

      IF V_ORGAO_ARRECAD = 'E' THEN
         FOR C_ESTADUAL IN (SELECT SUM(IP.VRIMPOSTONF) AS VRIMPOSTO, P.CDIMPOSTO, P.CDRECEITA, P.CDFORMPGTO, P.NRDIAFIXVENC, P.IDVENCDIANAOUTIL, P.CDFILIALCALEND, P.IDTPCALEND
                             FROM PARAMBENEFIMP B, PARAMGUIAIMPLOCAL P, IMPOSTO I, INSCRESTAD IE, IMPOSTONF IP
                            WHERE IE.CDEMPRESA        = P_CDEMPRESA
                              AND IE.CDINSCESTA       = P_CDINSCRICAO
                              AND IE.CDPAIS           = B.CDPAIS
                              AND IE.SGESTADO         = B.SGESTADO
                              AND B.IDTPPARAMBENEF    = 'E'
                              AND I.CDIMPOSTONFE      = P_CDIMPOSTO
                              AND P.CDIMPOSTO         = I.CDIMPOSTO
                              AND P.NRSEQPARAMBENIMP  = B.NRSEQPARAMBENIMP
                              AND P.CDIMPOSTO         = IP.CDIMPOSTO
                              AND (IP.NRSEQUMAPAPU    = P_NRSEQUMAPAPU OR IP.NRSEQMAPOIMP = P_NRSEQUMAPAPU)
                           GROUP BY P.CDIMPOSTO, P.CDRECEITA, P.CDFORMPGTO, P.NRDIAFIXVENC, P.IDVENCDIANAOUTIL, P.CDFILIALCALEND, P.IDTPCALEND) LOOP 

                 --IF C_ESTADUAL.CDRECEITA IS NOT NULL
                    IF V_NRDIAFIXVENC IS NULL THEN
                       V_DTVENCIMENTO := P_DTFINAL+1;
                    ELSE
                    IF V_NRDIAFIXVENC > TO_NUMBER(TO_CHAR(LAST_DAY(ADD_MONTHS(P_DTINICIAL, 1)),'DD')) THEN
                       V_DTVENCIMENTO := LAST_DAY(ADD_MONTHS(P_DTINICIAL,1));
                    ELSE
                       V_DTVENCIMENTO := TO_DATE(TO_CHAR(V_NRDIAFIXVENC)||'/'||TO_CHAR(ADD_MONTHS(P_DTINICIAL, 1), 'MM/YYYY'), 'DD/MM/YYYY');
                    END IF;
                 --END IF;

                 /* VERIFICA A FORMA DE PAGAMENTO */
                 IF V_CDFORMPGTO IS NOT NULL THEN
                    SELECT IDTIPODTPGTO, IDTPPERIODO, IDCONSDIAUTIL
                      INTO V_IDTIPODTPGTO, V_IDTPPERIODO, V_IDCONSDIAUTIL
                      FROM FORMPGTO
                     WHERE CDFORMPGTO = V_CDFORMPGTO;

                    IF V_IDTPPERIODO = 'M' THEN
                       V_DTVENCIMENTO := UTIL_CRIAVENCIMENTO.DIAMES(V_CDFORMPGTO,
                                                                    V_DTVENCIMENTO);
                    ELSIF V_IDTPPERIODO = 'S' THEN
                       V_DTVENCIMENTO := UTIL_CRIAVENCIMENTO.DIASEMANA(V_CDFORMPGTO,
                                                                       V_DTVENCIMENTO);
                    ELSE
                       V_DTVENCIMENTO := UTIL_CRIAVENCIMENTO.DIASEMANAMES(V_CDFORMPGTO,
                                                                          V_DTVENCIMENTO);
                    END IF;
                    CONSISTE_FERI_BANC(V_CDFILIALCALEND,
                                       V_DTVENCIMENTO,
                                       V_DTVENCIMENTO,
                                       V_IDCONSDIAUTIL,
                                       V_IDTPPERIODO,
                                       V_IDTPCALEND,
                                       V_IDVENCDIANAOUTIL);
                 ELSE
                    CONSISTE_FERI_BANC(V_CDFILIALCALEND,
                                       V_DTVENCIMENTO,
                                       V_DTVENCIMENTO,
                                       'S',
                                       'N',
                                       V_IDTPCALEND,
                                       V_IDVENCDIANAOUTIL);
                 END IF;

                 V_NRSEQGUIACOMPL := V_NRSEQGUIACOMPL+1;

                 IF C_ESTADUAL.CDRECEITA IS NOT NULL THEN
                    INSERT INTO GUIACOMPLMAPA
                       (NRSEQUMAPAPU, NRSEQGUIACOMPL, CDOBRIGAGUIA, CDRECEITAGUIA, DTVENCGUIACOMPL, IDORIGEMGUIA, VRRECEITAGUIA)
                    VALUES
                       (P_NRSEQUMAPAPU, LPAD(V_NRSEQGUIACOMPL,10,0), LPAD(V_NRSEQGUIACOMPL,5,0), C_ESTADUAL.CDRECEITA, V_DTVENCIMENTO, '9', C_ESTADUAL.VRIMPOSTO);

                    V_TOTALGUIACOMPL := V_TOTALGUIACOMPL + C_ESTADUAL.VRIMPOSTO;
                 END IF;
              END IF;
         END LOOP;

         /*BUSCA CODIGO DA RECEITA POR IMPOSTO*/
         BEGIN
            SELECT CDRECEITA, CDFORMPGTO, NRDIAFIXVENC, IDVENCDIANAOUTIL, CDFILIALCALEND, IDTPCALEND
              INTO V_CDRECEITA, V_CDFORMPGTO, V_NRDIAFIXVENC, V_IDVENCDIANAOUTIL, V_CDFILIALCALEND, V_IDTPCALEND
              FROM PARAMIMPOSGUIA P
             WHERE P.CDIMPOSTO = P_CDIMPOSTO;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDRECEITA        := NULL;
               V_CDFORMPGTO       := NULL;
               V_NRDIAFIXVENC     := NULL;
               V_IDVENCDIANAOUTIL := NULL;
               V_CDFILIALCALEND   := NULL;
               V_IDTPCALEND       := NULL;
         END;

         IF V_NRDIAFIXVENC IS NULL THEN
            V_DTVENCIMENTO := P_DTFINAL+1;
         ELSE
            IF V_NRDIAFIXVENC > TO_NUMBER(TO_CHAR(LAST_DAY(ADD_MONTHS(P_DTINICIAL, 1)),'DD')) THEN
               V_DTVENCIMENTO := LAST_DAY(ADD_MONTHS(P_DTINICIAL,1));
            ELSE
               V_DTVENCIMENTO := TO_DATE(TO_CHAR(V_NRDIAFIXVENC)||'/'||TO_CHAR(ADD_MONTHS(P_DTINICIAL, 1), 'MM/YYYY'), 'DD/MM/YYYY');
            END IF;
         END IF;

         /* VERIFICA A FORMA DE PAGAMENTO */
         IF V_CDFORMPGTO IS NOT NULL THEN
            SELECT IDTIPODTPGTO, IDTPPERIODO, IDCONSDIAUTIL
              INTO V_IDTIPODTPGTO, V_IDTPPERIODO, V_IDCONSDIAUTIL
              FROM FORMPGTO
             WHERE CDFORMPGTO = V_CDFORMPGTO;

            IF V_IDTPPERIODO = 'M' THEN
               V_DTVENCIMENTO := UTIL_CRIAVENCIMENTO.DIAMES(V_CDFORMPGTO,
                                                            V_DTVENCIMENTO);
            ELSIF V_IDTPPERIODO = 'S' THEN
               V_DTVENCIMENTO := UTIL_CRIAVENCIMENTO.DIASEMANA(V_CDFORMPGTO,
                                                               V_DTVENCIMENTO);
            ELSE
               V_DTVENCIMENTO := UTIL_CRIAVENCIMENTO.DIASEMANAMES(V_CDFORMPGTO,
                                                                  V_DTVENCIMENTO);
            END IF;
            CONSISTE_FERI_BANC(V_CDFILIALCALEND,
                               V_DTVENCIMENTO,
                               V_DTVENCIMENTO,
                               V_IDCONSDIAUTIL,
                               V_IDTPPERIODO,
                               V_IDTPCALEND,
                               V_IDVENCDIANAOUTIL);
         ELSE
            CONSISTE_FERI_BANC(V_CDFILIALCALEND,
                               V_DTVENCIMENTO,
                               V_DTVENCIMENTO,
                               'S',
                               'N',
                               V_IDTPCALEND,
                               V_IDVENCDIANAOUTIL);
         END IF;   
         
         IF V_TOTALGUIACOMPL = 0 THEN  
            SELECT VRTOTAIMPOS
              INTO V_VRMAPA
              FROM MAPAAPURAC
             WHERE NRSEQUMAPAPU = P_NRSEQUMAPAPU;

            INSERT INTO GUIACOMPLMAPA
               (NRSEQUMAPAPU, NRSEQGUIACOMPL, CDOBRIGAGUIA, CDRECEITAGUIA, DTVENCGUIACOMPL, IDORIGEMGUIA, VRRECEITAGUIA)
            VALUES
               (P_NRSEQUMAPAPU, LPAD(V_NRSEQGUIACOMPL,10,0), LPAD(V_NRSEQGUIACOMPL,5,0), V_CDRECEITA, V_DTVENCIMENTO, '9', V_VRMAPA);
               
            UPDATE MAPAAPURAC
               SET VRRECEGUIA   = VRTOTAIMPOS,
                   VRMULTAGUIA  = NVL(VRMULTAGUIA,0),
                   VRJUROGUIA   = NVL(VRJUROGUIA,0),
                   VRTOTAGUIA   = NVL(VRRECEGUIA,0) + NVL(VRMULTAGUIA,0) + NVL(VRJUROGUIA,0),
                   DTVENCGUIA   = V_DTVENCIMENTO,
                   CDRECEGUIA   = V_CDRECEITA
             WHERE NRSEQUMAPAPU = P_NRSEQUMAPAPU;
         ELSE
            UPDATE MAPAAPURAC
               SET VRRECEGUIA   = V_TOTALGUIACOMPL,
                   VRMULTAGUIA  = NVL(VRMULTAGUIA,0),
                   VRJUROGUIA   = NVL(VRJUROGUIA,0),
                   VRTOTAGUIA   = NVL(VRRECEGUIA,0) + NVL(VRMULTAGUIA,0) + NVL(VRJUROGUIA,0),
                   DTVENCGUIA   = V_DTVENCIMENTO,
                   CDRECEGUIA   = V_CDRECEITA
             WHERE NRSEQUMAPAPU = P_NRSEQUMAPAPU;

           /*VERIFICA SE TEM IMPOSTO QUE NAO TA PARAMETRIZADO NA LOCALIDADE POREM ESTA RELACIONADO AO IMPOSTONFE, GERANDO A GUIA PRINCIPAL COM A DIFERENCA*/
            BEGIN
               SELECT SUM(IP.VRIMPOSTONF)
                 INTO V_VRIMPOSTONF
                 FROM IMPOSTONF IP, IMPOSTO I
                WHERE (IP.NRSEQUMAPAPU = P_NRSEQUMAPAPU OR IP.NRSEQMAPOIMP = P_NRSEQUMAPAPU)
                  AND I.CDIMPOSTONFE  = P_CDIMPOSTO
                  AND IP.CDIMPOSTO    = I.CDIMPOSTO
                  AND NOT EXISTS (SELECT PL.CDIMPOSTO
                                    FROM PARAMBENEFIMP B, PARAMGUIAIMPLOCAL PL, IMPOSTO I, INSCRESTAD IE
                                   WHERE IE.CDEMPRESA         = P_CDEMPRESA
                                     AND IE.CDINSCESTA        = P_CDINSCRICAO
                                     AND IE.CDPAIS            = B.CDPAIS
                                     AND IE.SGESTADO          = B.SGESTADO
                                     AND B.IDTPPARAMBENEF     = 'E'
                                     AND I.CDIMPOSTONFE       = P_CDIMPOSTO
                                     AND PL.CDIMPOSTO         = I.CDIMPOSTO
                                     AND PL.NRSEQPARAMBENIMP  = B.NRSEQPARAMBENIMP
                                     AND IP.CDIMPOSTO         = PL.CDIMPOSTO);
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                 V_VRIMPOSTONF      := 0;
                 V_CDRECEITA        := NULL;
                 V_CDFORMPGTO       := NULL;
                 V_NRDIAFIXVENC     := NULL;
                 V_IDVENCDIANAOUTIL := NULL;
                 V_CDFILIALCALEND   := NULL;
                 V_IDTPCALEND       := NULL;
            END;

            IF V_VRIMPOSTONF > 0 THEN
               UPDATE MAPAAPURAC
                  SET VRRECEGUIA   = V_VRIMPOSTONF,
                      VRMULTAGUIA  = NVL(VRMULTAGUIA,0),
                      VRJUROGUIA   = NVL(VRJUROGUIA,0),
                      VRTOTAGUIA   = NVL(VRRECEGUIA,0) + NVL(VRMULTAGUIA,0) + NVL(VRJUROGUIA,0)
                 WHERE NRSEQUMAPAPU = P_NRSEQUMAPAPU;
            END IF;
         END IF;
      END IF; 

      IF V_ORGAO_ARRECAD = 'M' THEN
         FOR C_MUNICIPAL IN (SELECT SUM(IP.VRIMPOSTONF) AS VRIMPOSTO, P.CDIMPOSTO, P.CDRECEITA, P.CDFORMPGTO, P.NRDIAFIXVENC, P.IDVENCDIANAOUTIL, P.CDFILIALCALEND, P.IDTPCALEND
                             FROM PARAMBENEFIMP B, PARAMGUIAIMPLOCAL P, IMPOSTO I, INSCRMUNICIP IM, IMPOSTONF IP
                            WHERE IM.CDEMPRESA    = P_CDEMPRESA
                              AND IM.CDINSCMUNI   = P_CDINSCRICAO
                              AND IM.CDPAIS       = B.CDPAIS
                              AND IM.SGESTADO     = B.SGESTADO
                              AND IM.CDMUNICIPIO  = B.CDMUNICIPIO
                              AND B.IDTPPARAMBENEF    = 'M'
                              AND I.CDIMPOSTONFE      = P_CDIMPOSTO
                              AND P.CDIMPOSTO         = I.CDIMPOSTO
                              AND P.NRSEQPARAMBENIMP  = B.NRSEQPARAMBENIMP
                              AND P.CDIMPOSTO         = IP.CDIMPOSTO
                              AND (IP.NRSEQUMAPAPU    = P_NRSEQUMAPAPU OR IP.NRSEQMAPOIMP = P_NRSEQUMAPAPU)
                           GROUP BY P.CDIMPOSTO, P.CDRECEITA, P.CDFORMPGTO, P.NRDIAFIXVENC, P.IDVENCDIANAOUTIL, P.CDFILIALCALEND, P.IDTPCALEND) LOOP 

                 --IF C_MUNICIPAL.CDRECEITA IS NOT NULL
                    IF V_NRDIAFIXVENC IS NULL THEN
                       V_DTVENCIMENTO := P_DTFINAL+1;
                    ELSE
                    IF V_NRDIAFIXVENC > TO_NUMBER(TO_CHAR(LAST_DAY(ADD_MONTHS(P_DTINICIAL, 1)),'DD')) THEN
                       V_DTVENCIMENTO := LAST_DAY(ADD_MONTHS(P_DTINICIAL,1));
                    ELSE
                       V_DTVENCIMENTO := TO_DATE(TO_CHAR(V_NRDIAFIXVENC)||'/'||TO_CHAR(ADD_MONTHS(P_DTINICIAL, 1), 'MM/YYYY'), 'DD/MM/YYYY');
                    END IF;
                 --END IF;

                 /* VERIFICA A FORMA DE PAGAMENTO */
                 IF V_CDFORMPGTO IS NOT NULL THEN
                    SELECT IDTIPODTPGTO, IDTPPERIODO, IDCONSDIAUTIL
                      INTO V_IDTIPODTPGTO, V_IDTPPERIODO, V_IDCONSDIAUTIL
                      FROM FORMPGTO
                     WHERE CDFORMPGTO = V_CDFORMPGTO;

                    IF V_IDTPPERIODO = 'M' THEN
                       V_DTVENCIMENTO := UTIL_CRIAVENCIMENTO.DIAMES(V_CDFORMPGTO,
                                                                    V_DTVENCIMENTO);
                    ELSIF V_IDTPPERIODO = 'S' THEN
                       V_DTVENCIMENTO := UTIL_CRIAVENCIMENTO.DIASEMANA(V_CDFORMPGTO,
                                                                       V_DTVENCIMENTO);
                    ELSE
                       V_DTVENCIMENTO := UTIL_CRIAVENCIMENTO.DIASEMANAMES(V_CDFORMPGTO,
                                                                          V_DTVENCIMENTO);
                    END IF;
                    CONSISTE_FERI_BANC(V_CDFILIALCALEND,
                                       V_DTVENCIMENTO,
                                       V_DTVENCIMENTO,
                                       V_IDCONSDIAUTIL,
                                       V_IDTPPERIODO,
                                       V_IDTPCALEND,
                                       V_IDVENCDIANAOUTIL);
                 ELSE
                    CONSISTE_FERI_BANC(V_CDFILIALCALEND,
                                       V_DTVENCIMENTO,
                                       V_DTVENCIMENTO,
                                       'S',
                                       'N',
                                       V_IDTPCALEND,
                                       V_IDVENCDIANAOUTIL);
                 END IF;

                 V_NRSEQGUIACOMPL := V_NRSEQGUIACOMPL+1;

                 IF C_MUNICIPAL.CDRECEITA IS NOT NULL THEN
                    INSERT INTO GUIACOMPLMAPA
                       (NRSEQUMAPAPU, NRSEQGUIACOMPL, CDOBRIGAGUIA, CDRECEITAGUIA, DTVENCGUIACOMPL, IDORIGEMGUIA, VRRECEITAGUIA)
                    VALUES
                       (P_NRSEQUMAPAPU, LPAD(V_NRSEQGUIACOMPL,10,0), LPAD(V_NRSEQGUIACOMPL,5,0), C_MUNICIPAL.CDRECEITA, V_DTVENCIMENTO, '9', C_MUNICIPAL.VRIMPOSTO);

                    V_TOTALGUIACOMPL := V_TOTALGUIACOMPL + C_MUNICIPAL.VRIMPOSTO;
                 END IF;
              END IF;
         END LOOP;

         /*BUSCA CODIGO DA RECEITA POR IMPOSTO*/
         BEGIN
            SELECT CDRECEITA, CDFORMPGTO, NRDIAFIXVENC, IDVENCDIANAOUTIL, CDFILIALCALEND, IDTPCALEND
              INTO V_CDRECEITA, V_CDFORMPGTO, V_NRDIAFIXVENC, V_IDVENCDIANAOUTIL, V_CDFILIALCALEND, V_IDTPCALEND
              FROM PARAMIMPOSGUIA P
             WHERE P.CDIMPOSTO = P_CDIMPOSTO;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDRECEITA        := NULL;
               V_CDFORMPGTO       := NULL;
               V_NRDIAFIXVENC     := NULL;
               V_IDVENCDIANAOUTIL := NULL;
               V_CDFILIALCALEND   := NULL;
               V_IDTPCALEND       := NULL;
         END;

         IF V_NRDIAFIXVENC IS NULL THEN
            V_DTVENCIMENTO := P_DTFINAL+1;
         ELSE
            IF V_NRDIAFIXVENC > TO_NUMBER(TO_CHAR(LAST_DAY(ADD_MONTHS(P_DTINICIAL, 1)),'DD')) THEN
               V_DTVENCIMENTO := LAST_DAY(ADD_MONTHS(P_DTINICIAL,1));
            ELSE
               V_DTVENCIMENTO := TO_DATE(TO_CHAR(V_NRDIAFIXVENC)||'/'||TO_CHAR(ADD_MONTHS(P_DTINICIAL, 1), 'MM/YYYY'), 'DD/MM/YYYY');
            END IF;
         END IF;

         /* VERIFICA A FORMA DE PAGAMENTO */
         IF V_CDFORMPGTO IS NOT NULL THEN
            SELECT IDTIPODTPGTO, IDTPPERIODO, IDCONSDIAUTIL
              INTO V_IDTIPODTPGTO, V_IDTPPERIODO, V_IDCONSDIAUTIL
              FROM FORMPGTO
             WHERE CDFORMPGTO = V_CDFORMPGTO;

            IF V_IDTPPERIODO = 'M' THEN
               V_DTVENCIMENTO := UTIL_CRIAVENCIMENTO.DIAMES(V_CDFORMPGTO,
                                                            V_DTVENCIMENTO);
            ELSIF V_IDTPPERIODO = 'S' THEN
               V_DTVENCIMENTO := UTIL_CRIAVENCIMENTO.DIASEMANA(V_CDFORMPGTO,
                                                               V_DTVENCIMENTO);
            ELSE
               V_DTVENCIMENTO := UTIL_CRIAVENCIMENTO.DIASEMANAMES(V_CDFORMPGTO,
                                                                  V_DTVENCIMENTO);
            END IF;
            CONSISTE_FERI_BANC(V_CDFILIALCALEND,
                               V_DTVENCIMENTO,
                               V_DTVENCIMENTO,
                               V_IDCONSDIAUTIL,
                               V_IDTPPERIODO,
                               V_IDTPCALEND,
                               V_IDVENCDIANAOUTIL);
         ELSE
            CONSISTE_FERI_BANC(V_CDFILIALCALEND,
                               V_DTVENCIMENTO,
                               V_DTVENCIMENTO,
                               'S',
                               'N',
                               V_IDTPCALEND,
                               V_IDVENCDIANAOUTIL);
         END IF;
         
         IF V_TOTALGUIACOMPL = 0 THEN  
            SELECT VRTOTAIMPOS
              INTO V_VRMAPA
              FROM MAPAAPURAC
             WHERE NRSEQUMAPAPU = P_NRSEQUMAPAPU;

            INSERT INTO GUIACOMPLMAPA
               (NRSEQUMAPAPU, NRSEQGUIACOMPL, CDOBRIGAGUIA, CDRECEITAGUIA, DTVENCGUIACOMPL, IDORIGEMGUIA, VRRECEITAGUIA)
            VALUES
               (P_NRSEQUMAPAPU, LPAD(V_NRSEQGUIACOMPL,10,0), LPAD(V_NRSEQGUIACOMPL,5,0), V_CDRECEITA, V_DTVENCIMENTO, '9', V_VRMAPA);
               
            UPDATE MAPAAPURAC
               SET VRRECEGUIA   = VRTOTAIMPOS,
                   VRMULTAGUIA  = NVL(VRMULTAGUIA,0),
                   VRJUROGUIA   = NVL(VRJUROGUIA,0),
                   VRTOTAGUIA   = NVL(VRRECEGUIA,0) + NVL(VRMULTAGUIA,0) + NVL(VRJUROGUIA,0),
                   DTVENCGUIA   = V_DTVENCIMENTO,
                   CDRECEGUIA   = V_CDRECEITA
             WHERE NRSEQUMAPAPU = P_NRSEQUMAPAPU;
         ELSE
            UPDATE MAPAAPURAC
               SET VRRECEGUIA   = V_TOTALGUIACOMPL,
                   VRMULTAGUIA  = NVL(VRMULTAGUIA,0),
                   VRJUROGUIA   = NVL(VRJUROGUIA,0),
                   VRTOTAGUIA   = NVL(VRRECEGUIA,0) + NVL(VRMULTAGUIA,0) + NVL(VRJUROGUIA,0),
                   DTVENCGUIA   = V_DTVENCIMENTO,
                   CDRECEGUIA   = V_CDRECEITA
             WHERE NRSEQUMAPAPU = P_NRSEQUMAPAPU;

           /*VERIFICA SE TEM IMPOSTO QUE NAO TA PARAMETRIZADO NA LOCALIDADE POREM ESTA RELACIONADO AO IMPOSTONFE, GERANDO A GUIA PRINCIPAL COM A DIFERENCA*/
            BEGIN
               SELECT SUM(IP.VRIMPOSTONF)
                 INTO V_VRIMPOSTONF
                 FROM IMPOSTONF IP, IMPOSTO I
                WHERE (IP.NRSEQUMAPAPU = P_NRSEQUMAPAPU OR IP.NRSEQMAPOIMP = P_NRSEQUMAPAPU)
                  AND I.CDIMPOSTONFE  = P_CDIMPOSTO
                  AND IP.CDIMPOSTO    = I.CDIMPOSTO
                  AND NOT EXISTS (SELECT PL.CDIMPOSTO
                                    FROM PARAMBENEFIMP B, PARAMGUIAIMPLOCAL PL, IMPOSTO I, INSCRMUNICIP IM
                                   WHERE IM.CDEMPRESA         = P_CDEMPRESA
                                     AND IM.CDINSCMUNI        = P_CDINSCRICAO
                                     AND IM.CDPAIS            = B.CDPAIS
                                     AND IM.SGESTADO          = B.SGESTADO
                                     AND IM.CDMUNICIPIO       = B.CDMUNICIPIO
                                     AND B.IDTPPARAMBENEF     = 'M'
                                     AND I.CDIMPOSTONFE       = P_CDIMPOSTO
                                     AND PL.CDIMPOSTO         = I.CDIMPOSTO
                                     AND PL.NRSEQPARAMBENIMP  = B.NRSEQPARAMBENIMP
                                     AND IP.CDIMPOSTO         = PL.CDIMPOSTO);
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                 V_VRIMPOSTONF      := 0;
                 V_CDRECEITA        := NULL;
                 V_CDFORMPGTO       := NULL;
                 V_NRDIAFIXVENC     := NULL;
                 V_IDVENCDIANAOUTIL := NULL;
                 V_CDFILIALCALEND   := NULL;
                 V_IDTPCALEND       := NULL;
            END;

            IF V_VRIMPOSTONF > 0 THEN
               UPDATE MAPAAPURAC
                  SET VRRECEGUIA   = V_VRIMPOSTONF,
                      VRMULTAGUIA  = NVL(VRMULTAGUIA,0),
                      VRJUROGUIA   = NVL(VRJUROGUIA,0),
                      VRTOTAGUIA   = NVL(VRRECEGUIA,0) + NVL(VRMULTAGUIA,0) + NVL(VRJUROGUIA,0)
                 WHERE NRSEQUMAPAPU = P_NRSEQUMAPAPU;
            END IF;
         END IF;
      END IF; 
   END IF;
END;
/